"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParseFunctionsPlugin = void 0;
var webpack_1 = require("webpack");
var prettier_1 = __importDefault(require("prettier"));
var eta = __importStar(require("eta"));
var glob_1 = __importDefault(require("glob"));
var path_1 = __importDefault(require("path"));
var fs_1 = __importDefault(require("fs"));
eta.configure({
    views: path_1.default.resolve(__dirname, '../templates'),
});
/* === TYPES === */
var NativeHookNames;
(function (NativeHookNames) {
    NativeHookNames["beforeSave"] = "beforeSave";
    NativeHookNames["afterSave"] = "afterSave";
    NativeHookNames["beforeDelete"] = "beforeDelete";
    NativeHookNames["afterDelete"] = "afterDelete";
})(NativeHookNames || (NativeHookNames = {}));
var AdditionalBeforeSaveHookNames;
(function (AdditionalBeforeSaveHookNames) {
    AdditionalBeforeSaveHookNames["beforeCreate"] = "beforeCreate";
    AdditionalBeforeSaveHookNames["beforeUpdate"] = "beforeUpdate";
})(AdditionalBeforeSaveHookNames || (AdditionalBeforeSaveHookNames = {}));
var AdditionalAfterSaveHookNames;
(function (AdditionalAfterSaveHookNames) {
    AdditionalAfterSaveHookNames["afterCreate"] = "afterCreate";
    AdditionalAfterSaveHookNames["afterUpdate"] = "afterUpdate";
})(AdditionalAfterSaveHookNames || (AdditionalAfterSaveHookNames = {}));
var CronHookNames;
(function (CronHookNames) {
    CronHookNames["hourly"] = "hourly";
    CronHookNames["daily"] = "daily";
    CronHookNames["weekly"] = "weekly";
    CronHookNames["monthly"] = "monthly";
    CronHookNames["datetime"] = "datetime";
})(CronHookNames || (CronHookNames = {}));
var SubhooksMap = (_a = {},
    _a[NativeHookNames.beforeSave] = [
        AdditionalBeforeSaveHookNames.beforeUpdate,
        AdditionalBeforeSaveHookNames.beforeCreate,
    ],
    _a[NativeHookNames.afterSave] = [
        AdditionalAfterSaveHookNames.afterUpdate,
        AdditionalAfterSaveHookNames.afterCreate,
    ],
    _a[NativeHookNames.beforeDelete] = [],
    _a[NativeHookNames.afterDelete] = [],
    _a);
var AdditionalHookNames = __assign(__assign({}, AdditionalAfterSaveHookNames), AdditionalBeforeSaveHookNames);
var HookNames = __assign(__assign(__assign({}, NativeHookNames), AdditionalHookNames), CronHookNames);
var ParseServiceSchemaFieldType;
(function (ParseServiceSchemaFieldType) {
    ParseServiceSchemaFieldType["String"] = "String";
    ParseServiceSchemaFieldType["ACL"] = "ACL";
    ParseServiceSchemaFieldType["Date"] = "Date";
    ParseServiceSchemaFieldType["Relation"] = "Relation";
    ParseServiceSchemaFieldType["Pointer"] = "Pointer";
    ParseServiceSchemaFieldType["Object"] = "Object";
    ParseServiceSchemaFieldType["Array"] = "Array";
    ParseServiceSchemaFieldType["Boolean"] = "Boolean";
})(ParseServiceSchemaFieldType || (ParseServiceSchemaFieldType = {}));
/* === PLUGIN === */
var DEFAULT_OPTIONS = {
    functionDirectory: 'src/functions',
    moduleAlias: '@@functions',
};
var ParseFunctionsPlugin = /** @class */ (function () {
    function ParseFunctionsPlugin(opts) {
        var _this = this;
        Object.defineProperty(this, "options", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "basePath", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "buildPath", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "schemaPaths", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "indexFilePath", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "startBuild", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: function (compilation) { return __awaiter(_this, void 0, void 0, function () {
                var services, helpersFile, typesFile, indexFile;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            // clean build folder
                            try {
                                fs_1.default.rmSync(this.buildPath, { recursive: true });
                            }
                            catch (err) {
                                console.warn('[PARSE FUNCTIONS PLUGIN]', 'No build folder found; creating one now');
                            }
                            fs_1.default.mkdirSync(this.buildPath);
                            services = this.schemaPaths.reduce(function (memo, schemaPath) {
                                var p = schemaPath.split(path_1.default.sep);
                                var serviceDirName = p[p.length - 2];
                                var servicePath = path_1.default.join(_this.basePath, serviceDirName);
                                var configPath = path_1.default.join(servicePath, 'config.ts');
                                var schema = JSON.parse(fs_1.default.readFileSync(schemaPath, { encoding: 'utf-8' }));
                                var config = fs_1.default.existsSync(configPath) ? configPath.replace(_this.basePath, '..') : undefined;
                                var triggers = glob_1.default.sync("".concat(servicePath, "/triggers/*"));
                                var functions = glob_1.default.sync("".concat(servicePath, "/functions/**/*"));
                                var jobs = glob_1.default.sync("".concat(servicePath, "/jobs/**/*"));
                                var hooks = Object.values(HookNames).reduce(function (hMemo, hookName) {
                                    var hookPaths = glob_1.default.sync("".concat(servicePath, "/").concat(hookName, "/*"));
                                    var hookConfig = hookPaths.find(function (path) { return /\/config\.t|js$/.test(path); });
                                    if (hookConfig) {
                                        hookPaths.splice(hookPaths.indexOf(hookConfig), 1);
                                    }
                                    hMemo[hookName] = {
                                        hooks: hookPaths,
                                        config: hookConfig,
                                    };
                                    return hMemo;
                                }, {});
                                memo[serviceDirName] = {
                                    name: serviceDirName,
                                    basePath: _this.basePath,
                                    className: schema.className,
                                    schema: schema,
                                    schemaPath: schemaPath,
                                    functions: functions,
                                    triggers: triggers,
                                    hooks: hooks,
                                    jobs: jobs,
                                    config: config,
                                };
                                return memo;
                            }, {});
                            return [4 /*yield*/, this.makeHelpersFile(services)];
                        case 1:
                            helpersFile = _a.sent();
                            fs_1.default.writeFileSync(path_1.default.resolve("".concat(this.buildPath), 'helpers.ts'), helpersFile);
                            return [4 /*yield*/, this.makeTypesFile(services)];
                        case 2:
                            typesFile = _a.sent();
                            fs_1.default.writeFileSync(path_1.default.resolve("".concat(this.buildPath), 'types.ts'), typesFile);
                            Object.entries(services).forEach(function (_a) {
                                var serviceName = _a[0], service = _a[1];
                                return __awaiter(_this, void 0, void 0, function () {
                                    var servicePath, _b, _c, _d;
                                    return __generator(this, function (_e) {
                                        switch (_e.label) {
                                            case 0:
                                                servicePath = path_1.default.resolve(this.buildPath, "".concat(serviceName, ".ts"));
                                                compilation.fileDependencies.add(this.indexFilePath);
                                                _c = (_b = fs_1.default).writeFileSync;
                                                _d = [servicePath];
                                                return [4 /*yield*/, this.makeServiceFile(service)];
                                            case 1:
                                                _c.apply(_b, _d.concat([_e.sent()]));
                                                return [2 /*return*/];
                                        }
                                    });
                                });
                            });
                            return [4 /*yield*/, this.makeServiceIndexFile(services)];
                        case 3:
                            indexFile = _a.sent();
                            fs_1.default.writeFileSync(this.indexFilePath, indexFile);
                            compilation.fileDependencies.add(this.indexFilePath);
                            return [2 /*return*/];
                    }
                });
            }); }
        });
        this.options = Object.assign({}, DEFAULT_OPTIONS, opts);
    }
    Object.defineProperty(ParseFunctionsPlugin.prototype, "templateHelpers", {
        get: function () {
            return {
                SubhooksMap: SubhooksMap,
                CronHookNames: CronHookNames,
                AdditionalHookNames: AdditionalHookNames,
                removeExtension: removeExtension,
                mapSchemaTypeToTSType: mapSchemaTypeToTSType,
                createImportFromFilename: createImportFromFilename,
                getSanitizedFunctionName: getSanitizedFunctionName,
            };
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ParseFunctionsPlugin.prototype, "apply", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (compiler) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    this.basePath = path_1.default.resolve("".concat(compiler.context), this.options.functionDirectory);
                    this.schemaPaths = glob_1.default.sync("".concat(this.basePath, "/**/schema.json"));
                    this.buildPath = path_1.default.resolve(this.basePath, '.build');
                    this.indexFilePath = path_1.default.resolve(this.buildPath, "index.ts");
                    compiler.hooks.compilation.tap(this.constructor.name, this.startBuild);
                    // Look for import of modules that begins with `@@function` and replace with build folder
                    new webpack_1.NormalModuleReplacementPlugin(/^@@functions(.*)/, function (resource) {
                        resource.request = resource.request.replace(_this.options.moduleAlias, _this.buildPath);
                    }).apply(compiler);
                    return [2 /*return*/];
                });
            });
        }
    });
    Object.defineProperty(ParseFunctionsPlugin.prototype, "makeHelpersFile", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (services) {
            return __awaiter(this, void 0, void 0, function () {
                var helpersFileString, f;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, eta.renderFile('helpers.eta', { services: services, helpers: this.templateHelpers })];
                        case 1:
                            helpersFileString = _a.sent();
                            f = prettier_1.default.format(helpersFileString, { parser: 'typescript', printWidth: 112 });
                            return [2 /*return*/, f];
                    }
                });
            });
        }
    });
    Object.defineProperty(ParseFunctionsPlugin.prototype, "makeTypesFile", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (services) {
            return __awaiter(this, void 0, void 0, function () {
                var typesFileString, f;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, eta.renderFile('types.eta', { services: services, helpers: this.templateHelpers })];
                        case 1:
                            typesFileString = _a.sent();
                            f = prettier_1.default.format(typesFileString, { parser: 'typescript', printWidth: 112 });
                            return [2 /*return*/, f];
                    }
                });
            });
        }
    });
    Object.defineProperty(ParseFunctionsPlugin.prototype, "makeServiceIndexFile", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (services) {
            return __awaiter(this, void 0, void 0, function () {
                var indexFileString, f;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, eta.renderFile('index.eta', { services: services, helpers: this.templateHelpers })];
                        case 1:
                            indexFileString = _a.sent();
                            f = prettier_1.default.format(indexFileString, { parser: 'typescript', printWidth: 112 });
                            return [2 /*return*/, f];
                    }
                });
            });
        }
    });
    Object.defineProperty(ParseFunctionsPlugin.prototype, "makeServiceFile", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (service) {
            return __awaiter(this, void 0, void 0, function () {
                var serviceFileString, f;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, eta.renderFile('service.eta', { service: service, helpers: this.templateHelpers })];
                        case 1:
                            serviceFileString = _a.sent();
                            f = prettier_1.default.format(serviceFileString, { parser: 'typescript', printWidth: 112 });
                            return [2 /*return*/, f];
                    }
                });
            });
        }
    });
    return ParseFunctionsPlugin;
}());
exports.ParseFunctionsPlugin = ParseFunctionsPlugin;
/* === TEMPLATE HELPERS === */
function removeExtension(filePath) {
    return filePath.replace(/\.(t|j)s$/, '');
}
function createImportFromFilename(filePath, prefix, basePath) {
    if (prefix === void 0) { prefix = ''; }
    if (basePath === void 0) { basePath = ''; }
    return "import ".concat(getSanitizedFunctionName(filePath, prefix), " from '").concat(filePath.replace(/\.ts$/, '').replace(basePath, '..'), "';");
}
function getSanitizedFunctionName(filePath, prefix) {
    if (prefix === void 0) { prefix = ''; }
    var ext = path_1.default.extname(filePath);
    var fileName = path_1.default.basename(filePath, ext)
        .replace(/^(\d_)|\d\./g, '')
        .replace(/[^a-zA-Z]/g, '_');
    return prefix ? "".concat(prefix).concat(fileName) : fileName;
}
function mapSchemaTypeToTSType(schemaField) {
    switch (schemaField.type) {
        case ParseServiceSchemaFieldType.Relation:
            return "Parse.Relation";
        // return `Parse.Relation<${schemaField.targetClass}>`
        case ParseServiceSchemaFieldType.Pointer:
            return "Parse.Pointer";
        case ParseServiceSchemaFieldType.String:
        case ParseServiceSchemaFieldType.ACL:
            return 'string';
        case ParseServiceSchemaFieldType.Boolean:
            return 'boolean';
        case ParseServiceSchemaFieldType.Date:
            return 'Date';
        case ParseServiceSchemaFieldType.Object:
            return '{ [key: string]: any }';
        case ParseServiceSchemaFieldType.Array:
            return 'any[]';
        default: return 'string';
    }
}
exports.default = ParseFunctionsPlugin;
//# sourceMappingURL=main.js.map